
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;


public class parash {

	public static void main(String[] args) {
		//int[][] map = { {4, 4, 4, 4} , {4, 4, 4, 4}, {4, 4, 4, 4} }; // 
		//final int[][] animalBodyConst = {{1, 1}, {1, 1}};
		//final int[][] animalBodyConst1 = {{1, 1}, {1, 1}, {1, 1}, {1, 1}, {1, 1}};
		//Animal animal1 = new Animal(animalBodyConst1, 3, 2);
		//Animal animal2 = new Animal(animalBodyConst1, 4, 10);
		//Animal animal3 = new Animal(animalBodyConst1, 4, 5);
		//Animal animal4 = new Animal(animalBodyConst, 10, 5);
		//Animal animal5 = new Animal(animalBodyConst, 100, 5);
		//Animal animal6 = new Animal(animalBodyConst, 3, 5);
		int[][] map;
		Animal tempAnimal = new Animal();
		int[][] newAnimalBody;
		int influence, safety;
		List<int[]> fallingCoordinates = new LinkedList<int[]>(); //This is all coordinates for animals which were fell
		List<Animal> animals;//List with all animals (2)
		int[] checkPutAnimal = new int[2];
		int animalIterator = 0;
		String line = new String();
		char[] char1;
		String str;
		List<Integer> orderOfFellAnimals;//for order of animals who were fell
		
		
		File inputFile = null;
		File outputFile = null;
		Scanner fileReader = null;
		PrintWriter fileWriter = null;
		
		int mapNumberOfRows, mapNumberOfColumns, numberOfAnimals, animalBodyNumberOfRows, animalBodyNumberOfColumns;
		
		try{
			inputFile = new File("parash.in");
			outputFile = new File("parash.out");
			fileReader = new Scanner(inputFile);
			fileWriter = new PrintWriter(outputFile);
			
			mapNumberOfRows = fileReader.nextInt();
			mapNumberOfColumns = fileReader.nextInt();
			numberOfAnimals = fileReader.nextInt();
			animals = new ArrayList<Animal>(numberOfAnimals);
			orderOfFellAnimals = new ArrayList<Integer>(numberOfAnimals);
			map = new int[mapNumberOfRows][mapNumberOfColumns];
			
			for(int e=0; e<numberOfAnimals; e++){
				animals.add(new Animal());
			}
			
			for(int b=0; b<mapNumberOfRows; b++){
				for(int h=0; h<mapNumberOfColumns; h++){
					map[b][h] = fileReader.nextInt();
				}
			}
			
			for(int j=0; j<numberOfAnimals; j++){
				animalBodyNumberOfRows = fileReader.nextInt();
				animalBodyNumberOfColumns = fileReader.nextInt();
				influence = fileReader.nextInt();
				safety = fileReader.nextInt();
				newAnimalBody = new int[animalBodyNumberOfRows][animalBodyNumberOfColumns];
				//fileReader.useDelimiter(pattern);
				line = fileReader.nextLine();

				for(int e=0; e<animalBodyNumberOfRows; e++){
					line = fileReader.nextLine();
					//row = Integer.parseInt(line);
					char1 = line.toCharArray();
					for(int w=0; w<animalBodyNumberOfColumns; w++){
						str = Character.toString(char1[w]);
						newAnimalBody[e][w] = Integer.parseInt(str);
						
					}
				}
				
				tempAnimal=animals.get(j);
				tempAnimal.setAnimalBody(newAnimalBody);
				tempAnimal.setInfluence(influence);
				tempAnimal.setSafety(safety);
				tempAnimal.setOrderNum(j);
				//animals.set(j, tempAnimal);
			}				
			
			/*System.out.println("numberOfAnimals= "+ numberOfAnimals);
			for(int i=0; i<map.length; i++){
				for(int j=0; j<map[0].length; j++){
					System.out.print(map[i][j]+" ");
				}
				System.out.println();
			}
			for(int y=0; y<animals.size(); y++){
				tempAnimal = animals.get(y);
				tempAnimal.printAnimal();
			}*/
			
			if(animals.size() > 0){
				sortAnimals(animals);
				
				for(animalIterator=0; animalIterator<animals.size(); animalIterator++){
					tempAnimal = animals.get(animalIterator);
					//tempAnimal.printAnimal();
					if(checkAnimalDimmensions(map, animals.get(animalIterator)) == true){
						checkPutAnimal = putAnimal(map, animals.get(animalIterator));
						if( (checkPutAnimal[0] != -1) && (checkPutAnimal[1] != -1) ){
							fallingCoordinates.add( checkPutAnimal );
							orderOfFellAnimals.add(tempAnimal.getOrderNum());
							
							changeMap(map, fallingCoordinates.get(fallingCoordinates.size()-1), animals.get(animalIterator) );
							
							//Prints changed map
							/*System.out.println("Changed map");
							for(int i=0; i<map.length; i++){
								for(int j=0; j<map[0].length; j++){
									System.out.print(map[i][j]+" ");
								}
								System.out.println();
							}*/
						}
					}
					else{//animal body dimension is bigger than map
					}
				}
			}
			else{//animals.size()==0 
			}
			
			if(fallingCoordinates.size()>0){
				fileWriter.println(orderOfFellAnimals.size());
				int s=0;
				int[] coord = new int[2];
				do{
					coord = fallingCoordinates.get(s);
					fileWriter.println((orderOfFellAnimals.get(s)+1)+" " + (coord[0]+1) + " " + (coord[1]+1) );
					s++;
				}while(s < orderOfFellAnimals.size());
			}
			
			
		}
		catch(FileNotFoundException fnfex){
			//fnfex.getMessage();
		}
		finally{
			try{
				fileReader.close();
				fileWriter.close();
			}
			catch(Exception ex){
				//System.out.println(ex.getMessage());
			}
		}
		
		
		//animals.add(animal1);
		//animals.add(animal2);
		//animals.add(animal3);
		//animals.add(animal4);
		//animals.add(animal5);
		//animals.add(animal6);
		//animal2.printAnimal();
		
					
		
		
	}

	public static int[] putAnimal(int[][] map, Animal animal){
		int[][] animalBody = animal.getAnimalBody();
		List<Integer> safetyCoordinates = new LinkedList<Integer>();
		int[][] allPossibleCoordinates;
		int i=0;
		boolean isSafety = false;
		int maxSafetyYIndex;
		int[] maxSafetyCoordinate = new int[2];
		int differenceX = map[0].length - animalBody[0].length;
		int differenceY = map.length - animalBody.length;
		allPossibleCoordinates = new int[(differenceX+1)*(differenceY+1)][2];

		//finds all possible coordinates for falling and than safety coordinates
		for(int y=0; y<=differenceY; y++){
			for(int x=0; x<=differenceX; x++){
				allPossibleCoordinates[i][0] = y;
				allPossibleCoordinates[i][1] = x;
				i++;
				isSafety = checkPosition(map, x, y, animal);
				if(isSafety == true){
					safetyCoordinates.add( y );
					safetyCoordinates.add( x );
				}
			}
		}
		
		if(safetyCoordinates.size() != 0){
			//finds Y index in safetyCoordinates LinkedList with max safety
			maxSafetyYIndex = findMaxSafetyCoord(map, safetyCoordinates, animalBody);
			
			//Checks that allPossible coordinates works correctly - yes
			/*System.out.println("allPossible coordinates ");
			for(int k=0; k<allPossibleCoordinates.length; k++){
				for(int m=0; m<allPossibleCoordinates[0].length; m++){
					System.out.print(allPossibleCoordinates[k][m]);
					
				}
				System.out.print(" isSafety= " + checkPosition(map, allPossibleCoordinates[k][1], allPossibleCoordinates[k][0], animal) );
				System.out.println();
			}
			
			//Checks that safety coordinates works correctly - yes
			System.out.println("Safety Coordinates");
			
			for(int q=0; q<safetyCoordinates.size()-1; q=q+2){
				
				System.out.print( safetyCoordinates.get(q) + " "+ safetyCoordinates.get(q+1) );
				System.out.println();
			}
			
			//Checks that max safety coordinate works correctly
			System.out.println("maxSafetyCoordinate= " + safetyCoordinates.get(maxSafetyYIndex) + " " + safetyCoordinates.get(maxSafetyYIndex+1));
			*/
			maxSafetyCoordinate[0] = safetyCoordinates.get(maxSafetyYIndex);
			maxSafetyCoordinate[1] = safetyCoordinates.get(maxSafetyYIndex+1);
		}
		else{
			maxSafetyCoordinate[0] = -1;
			maxSafetyCoordinate[1] = -1;
		}
		
		
		return maxSafetyCoordinate;
	}
	
	//Checks that position is safety - 
	public static boolean checkPosition(int[][] map, int x, int y, Animal animal){
		boolean isSafety=false;
		int m=0;
		int k = 0;
		int[][] animalBody = animal.getAnimalBody();
		
		for(int i=y; i<(animalBody.length+y); i++){
			for(int j=x; j<(animalBody[0].length+x); j++){
				if( (animalBody[m][k]==1) && ((map[i][j]*animalBody[m][k]) < animal.getSafety()) ){
					isSafety=false;
					return isSafety;
				}
				k++;
			}
			m++;
			k=0;
		}
		
		isSafety=true;
		return isSafety;
	}
	
	//Finds Y index in safetyCoordinates LinkedList of the max safety coordinate  
	public static int findMaxSafetyCoord(int[][] map, List<Integer> safetyCoordinates, int[][] animalBody){
	
		int maxSafetyYIndex=0, maxSafety=0, safety=0;
		maxSafety = findAnimalTotalSafetyForCoordinate(map, animalBody, safetyCoordinates.get(0), safetyCoordinates.get(1));
		
		for(int i=0; i<safetyCoordinates.size()-1; i=i+2){
			//safety = map[safetyCoordinates.get(i)][safetyCoordinates.get(i+1)];
			safety = findAnimalTotalSafetyForCoordinate(map, animalBody, safetyCoordinates.get(i), safetyCoordinates.get(i+1));
			if(safety > maxSafety){
				maxSafety = safety;
				maxSafetyYIndex=i;
			}
		}
		
		return maxSafetyYIndex;
	}
	
	public static int findAnimalTotalSafetyForCoordinate(int[][] map, int[][] animalBody, int y, int x){
		int totalSafety = 0, m=0, k=0;
	
		for(int i=y; i<(animalBody.length+y); i++){
			for(int j=x; j<(animalBody[0].length+x); j++){
				if(animalBody[m][k]==1){
					totalSafety += map[i][j];
				}
				k++;
			}
			k=0;
			m++;
		}
		return totalSafety;
	}
	
	//Changes map by influence and animal body
	public static void changeMap(int[][] map, int[] fallingCoordinate, Animal animal){
		int[][] animalBody = animal.getAnimalBody();
		int[] coordinate = new int[2];
		coordinate = fallingCoordinate;
		//coordinate[0]=Y
		//coordinate[1]=x
		int m=0, k=0;
		
		for(int i=coordinate[0]; i<(animalBody.length + coordinate[0]); i++){
			for(int j=coordinate[1]; j<(animalBody[0].length + coordinate[1]); j++){
				if(animalBody[m][k]==1){
					map[i][j] = map[i][j] / animal.getInfluence();		
				}
				k++;
			}
			m++;
			k=0;
		}
	}
	
	//Checks that animalBody <= map
	public static boolean checkAnimalDimmensions(int[][] map, Animal animal){
		boolean isInMap = false;
		int[][] animalBody = animal.getAnimalBody();
		if( (animalBody.length <= map.length) && (animalBody[0].length <= map[0].length) ){
			isInMap = true;
		}
		
		return isInMap;
	}
	
	//Sort animals ArrayList in ascending order to influence
	public static void sortAnimals(List<Animal> animals){
		Animal animalWithMinInfluence; 
		for(int i=0; i<animals.size()-1; i++){
			for(int j=i+1; j<animals.size(); j++){
				if( findAnimalTotalInfluence((Animal)animals.get(j)) < findAnimalTotalInfluence((Animal)animals.get(i))){
					animalWithMinInfluence = (Animal)animals.get(j);
					animals.set(j, animals.get(i)) ;
					animals.set(i, animalWithMinInfluence );
				}
			}
		}
	}
	
	//Finds total influence in animal body
	public static int findAnimalTotalInfluence(Animal animal){
		int totalInfluence = 0;
		int[][] animalBody = animal.getAnimalBody();
		for(int y=0; y<animalBody.length; y++){
			for(int x=0; x<animalBody[0].length; x++){
				if(animalBody[y][x] == 1){
					totalInfluence += animal.getInfluence();
				}
			}
		}
		return totalInfluence;
	}
}
